//----------------------------------------------------------------
/* Are You Lucky?
/*  Written by Azuron 8.21(Wed.)
/* Oh!X 1992-2
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)

vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_SPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
sp_disableBG0SPBG1(YES)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,j,r,cp,hp,da,num,dead,mmx,mmy
str tit="Are You Lucky?"
dim int cd(52),btm(7),his(52),ba(7,5)

enum
	MS_CURSOR=1
endenum
sp_init():// ここでスプライト画面は非表示になる / Hide sprite screen
sp_image("x68mouseCursor.png",0,0,,,MS_CURSOR)

if NO then {
// テスト；カーソルパターンデータの表示
dim int ptn(256)
print "type=";sp_pat(MS_CURSOR,ptn)
r=0
for i=0 to 15
	for j=0 to 15
		print hex$(ptn(r));",";
		r=r+1
	next
	print
next
bitmapPattern(100,700,16,16,ptn)
bitmapImgLoad()
hitKey(NO)
}

width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

// 音声データ読み込み
dim int snd(3)
enum
	pasa=1
	boo
	pinpon
endenum

for i=1 to 3
//	gLocate(0,35+i)
//	print "lucky"+str$(i)+".mp3";
	snd(i)=a_setPlayData("lucky"+str$(i)+".mp3")
//	print "/";snd(i)
next

prep()
/* メイン
repeat
	vinit(0)
	vinit(1)
	shuffle()
	layout()
	hand_disp(1)
	da_disp(cd(cp))
	repeat
		r=select()
	until r<>0
	if r=3  then r=ending()
	if r<>2 then again()
until r=2

/* 終了
// 音声バッファー開放
for i=1 to 3
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

//------------------------------------------

func int select()
/* カードを選ぶ
int n,bl,br,mx,my,r=0
	// 前のタッチが離されるのを待つ
	while getTouchStatus()<>TOUCH_NONE:endwhile
	// タッチされるのを待つ
//gLocate(0,30):print "wait" 
	while getTouchStatus()=TOUCH_NONE
	endwhile
	//
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)

///	int rr,g,b,alpha:// for test bitmapPoint(,r,g,b,alpha) read
	apage(GPAGE2)
///	n=bitmapPoint(mx,my,rr,g,b,alpha)
	n=bitmapPoint(mx,my)
///	print
///	print "col=";hex$(n);"/r=";hex$(rr);"/g=";hex$(g);"/b=";hex$(b);"/α=";hex$(alpha)
	apage(GPAGE1)
	switch n
		case 0
			break
		case 1
			if b_to_d(1,mx,my) then SE(boo)
			break
		case 2
			if t_to_d(1) then SE(boo)
			break
		case 3
			if retry(224,"Sure?") then r=1
			break
		case 4
			if Rcheck() then SE(boo)
			break
		case 5
			//ending():// テスト！！
			if quit() then r=2
			break
	endswitch
	if num=35 then r=3
	return(r)
endfunc
/*
//------------------------------------------

func int b_to_d(sw,x,y)
/* 場札を台札に
int p
	p=(x-76)\52
	if sw and check(1,p,y) then return(1)
	da_disp(ba(p,btm(p)))
	btm(p)=btm(p)-1
	num=num+1
	erase(p)
	if sw then history(p)
	return(0)
endfunc
/*
//------------------------------------------

func int t_to_d(sw)
/* 手札を台札に
	if cp=51 then return(1)
	if sw then history(-1)
	cp=cp+1
	if cp=51 then fill16X68(128,400,175,495,0)
	hand_disp(0)
	da_disp(cd(cp))
	dead=0
	return(0)
endfunc
/*
//------------------------------------------

func da_disp(c)
/* 台札を表示
	cardPut(336,400,c,NO)
	SE(pasa)
	da=same(c)
endfunc
/*
//------------------------------------------

func erase(p)
/* 場札を消去
int i,x,y,b
	b=btm(p)
	x=p*52+76:y=(b+1)*48+80
	fill16X68(x,y,x+47,y+95,0)
	if b<>-1 then cardPut(x,y-48,ba(p,b),NO)
endfunc
/*
//------------------------------------------

func history(arg)
/* 歴史を作る
	his(hp)=arg
	hp=hp+1
endfunc
/*
//------------------------------------------

func hand_disp(sw)
/* 手札を表示
	if sw then cardPut(128,400,0,NO)
//	str s
//	s=itoa(51-cp)
//	fill16X68(144,496+4,159,511,0)
//	symbol16X68(144+(2-utf8StrWidth(s))*4,496+4,s,1,15,FONT,FNTSZ)
	locate(144,496+4)
	print using "##",51-cp
endfunc
/*
//------------------------------------------

func layout()
/* レイアウト
	for j=0 to 4
		for i=0 to 6
			ba(i,j)=cd(j*7+i)
			cardPut(i*52+76,j*48+80,cd(j*7+i),NO)
		next
	next
endfunc
/*
//------------------------------------------

func int check(sw,x,y)
/* 場札が台札にできるかチェック
int c,yy,f=0
	if dead=1    then return(1)
	if btm(x)=-1 then return(1)
	yy=btm(x)*48+80
	if sw=1 and (yy>y or yy+96<y) then return(1)
	/*
	c=same(ba(x,btm(x)))
	if abs(c-da)=12 then {
		if sw and da=13 and c=1 then dead=1
		return(f)
	}
	if abs(c-da)<>1 then f=1
	return(f)
endfunc
/*
//------------------------------------------

func int Rcheck()
/* まだ移動できるカードがあるかチェック
int i,x,y,f=0
	for i=0 to 6
	if check(0,i,0)=0 then f=1:break
	next
	if f then hako(i*52+76,btm(i)*48+80)
	if f=0 and cp=51 then return(1)
	if f=0 then hako(128,400)
	return(0)
endfunc
/*
//------------------------------------------

func hako(x,y)
/* ボックス表示
	apage(GPAGE0)
	box16X68(x-2,y-2,x+48,y+96,11)
	box16X68(x-1,y-1,x+47,y+95,11)
	SE(pinpon)
	fill16X68(x-2,y-2,x+48,y+96,0)
endfunc
/*
//------------------------------------------

func int retry(x,m;str)
/* 再挑戦
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度、やりますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Try again?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			return(1)
	endswitch
	return(0)
endfunc
/*
//------------------------------------------

func int quit()
/* やめるの？
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="終了しますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Quit game?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			return(1)
	endswitch
	return(0)
endfunc
/*
//------------------------------------------

func flbx(x0,y0,x1,y1,c0,c1)
/* fill16X68&box16X68
	fill16X68(x0,y0,x1,y1,c0)
	box16X68( x0,y0,x1,y1,c1)
endfunc
/*
//------------------------------------------

func cwait(t)
/* X68 10MHz n=500で42秒
	wait((42.0/500.0/5.0)*t)
//	int i
//	for i=0 to t*100:next
endfunc

/*
//------------------------------------------

func vinit(sw)
/* 変数初期化
	switch  sw
		case  0
			for i=0 to 51: cd(i)=i+1:next
			for i=0 to 51:his(i)= -2:next
			break
		case 1
			for i=0 to 6:btm(i)=4:next
			cp=35:hp=0
			num=0:dead=0
	endswitch
endfunc
/*
//------------------------------------------

func SE(t)
/* Sound Effect
	a_play(snd(t))
	repeat:until a_stat(t)=0
endfunc
/*
//------------------------------------------

func same(c)
/* 同位札を求める
	return((c-1) mod MAX_TRUMP+1)
endfunc
/*
//------------------------------------------

func shuffle()
/* シャッフル
int i,a,b,c
	for i=1 to 199
		a=rand() mod 52
		b=rand() mod 52
		c=cd(a):cd(a)=cd(b):cd(b)=c
	next
endfunc
/*
//------------------------------------------

func cur_move(x,y)
/* マウスカーソルを動かす
int mx,my,vx,vy
//	mspos(mx,my)
	sp_move(MS_CURSOR,mmx,mmy,MS_CURSOR)
	//
	mx=mmx:my=mmy
	vx=sgn(x-mx):vy=sgn(y-my)
	if vx=0 and vy=0 then return
	vx=vx*4:vy=vy*4
	repeat
		if abs(mx-x)>4 then mx=mx+vx
		if abs(my-y)>4 then my=my+vy
//		setmspos(mx,my)
		mmx=mx:mmy=my
		sp_move(MS_CURSOR,mmx,mmy,MS_CURSOR)
		cwait(3):// 6
	until abs(mx-x)<5 and abs(my-y)<5
endfunc
/*
//------------------------------------------

func ending()
int i,x,y,p
	again()
	wait(2)
	sp_disp(YES)
	//
	apage(GPAGE0)
	symbol16X68(180-28,200,tit						,2,11,FONT,FNTSZ)
	if isLocalizeJapan() then {
		symbol16X68(206,130,"特別企画"					,2, 9,FONT,FNTSZ)
		symbol16X68(140,270,"◇クリアまでの軌跡◇"			,2,15,FONT,FNTSZ)
	} else {
		symbol16X68(206,130,"Special Events"			,2, 9,FONT,FNTSZ)
		symbol16X68(140,270,"◇Trajectory to clear◇"	,2,15,FONT,FNTSZ)
	}
	wait(2)
	fill16X68(0,130,767,304,0):// メッセージを消す

	wait(0.5)
	mmx=256:mmy=256
	apage(GPAGE1)
	layout()
	vinit(1)
	hand_disp(1)
	da_disp(cd(cp))
	/*
	for i=0 to 51
		p=his(i)
		if p=-2 then break
		if p=-1 then {
			cur_move(152,448)
			t_to_d(0)
		} else {
			x=p*52+100:y=btm(p)*48+128
			cur_move(x,y)
			b_to_d(0,x,y)
		}
	next
	/*
	wait(2)
	sp_disp(NO)
	symbol16X68(176,220,localizedString("おめでとう！！"	  ,"Congratulations!!" ),2,15,FONT,FNTSZ)
	symbol16X68(190,280,localizedString("タップしてください","Please tap screen."),1,13,FONT,FNTSZ)

	// 前のタッチが離されるのを待つ
	while getTouchStatus()<>TOUCH_NONE:endwhile
	// タッチされるのを待つ
	repeat
	until getTouchStatus()<>TOUCH_NONE
	
	return(retry(220,"retry?")+2)
endfunc
/*
//------------------------------------------

func again()
	fill16X68( 76, 80,435,367,0)
	fill16X68(128,400,175,509,0)
	fill16X68(336,400,383,495,0)
endfunc

/*
//------------------------------------------

func prep()
/* 準備
	srand(val(mid$(time$,4,2)+right$(time$,2)))
	setgPalet16X68(1,&h000000ff):// palet(1,0)
	vpageX68(3,YES):// スプライト付き
	/*
	apage(GPAGE1)
	flbx( 54,36,160,70,14,15)
	flbx(200,36,306,70,14,15)
	flbx(346,36,452,70,14,15)
	symbol16X68( 76, 40,"retry",1.6, 0,FONT,FNTSZ)
	symbol16X68(222, 41,"check",1.6, 0,FONT,FNTSZ)
	symbol16X68(372, 40,"quit" ,1.6, 0,FONT,FNTSZ)
	symbol16X68(170-28,  0,tit ,2  ,13,FONT,FNTSZ)
	symbol16X68(136,382,localizedString("手札","hand"),1,15,FONT,FNTSZ)
	symbol16X68(344,382,localizedString("台札","lead"),1,15,FONT,FNTSZ)
	/* 仮想画面
	apage(GPAGE2)
	gColor(1)
	for i=0 to 6
		fill(i*52+76,80,i*52+123,367)
	next
	gColor(2):fill(126,400,175,495)
	gColor(3):fill( 54, 36,160, 70)
	gColor(4):fill(200, 36,306, 70)
	gColor(5):fill(346, 36,452, 70)
	/*
	apage(GPAGE1)
	mmx=256:mmy=256
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

///****************************************************************
